
local LII = LibStub:GetLibrary("LibItemInfo-1.0")

local colorYellow 		= "|cFFFF00" 	-- yellow 
local colorGreen 		= "|c00FF00" 	-- green
local colorRed 			= "|cFF0000" 	-- Red

--------------------------------------------------------------------
--  Process Item --
-- Determines if the itemType is handled by the addon before processing it to see if it is junk --
--------------------------------------------------------------------
--[[
local function ShouldProcessItem(_iBagId, _iSlotId)
	local isHandled, reason = JunkIt.IsAHandledItemType(_iBagId, _iSlotId)
	
	JunkIt.DebugWin:AddText(sJunkReason)
	if isHandled then return true end
	
	return false
end
--]]
----------------------------------------------------------
--  On Slot Update (called from: SlotUpdate(), called from EVENT_INVENTORY_SINGLE_SLOT_UPDATE) --
-- Main code to make calls to see if an item is Junk, set the item to junk (or not) and calls --
-- print chat messages. --
----------------------------------------------------------
function JunkIt.OnSlotUpdate(_iBagId, _iSlotId) 
	if not JunkIt.SavedVariables["JUNKMODE"] then return end
	
	local bIsItemJunk, sJunkReason = JunkIt.IsItemJunk(_iBagId, _iSlotId)
	
	SetItemIsJunk(_iBagId, _iSlotId, bIsItemJunk)
	JunkIt.PrintChatMessages(_iBagId,  _iSlotId, bIsItemJunk)
	JunkIt.DebugWin:AddText(sJunkReason)
	
	if bIsItemJunk then
		JunkIt.DestroyCheck(_iBagId, _iSlotId)
		return true
	end
	return false
end

-----------------------------------------------------------------
-- When using the consolidate area loot you still get gold updates for each body. We temporarily hold the amount for a few ms until the message is printed. So all of the gold can be added up.
----------------------------------------------------------------
function JunkIt.OnMoneyLooted(_iGoldAmount, _Reason) 
	if _iGoldAmount > 0 then
		-- If the gold holder is empty then we need to start a new (delayed) print gold message --
		if JunkIt.GoldGainHold == 0 then
			zo_callLater(function() 
				JunkIt.PrintGoldMessage(_Reason, true) 
				JunkIt.GoldGainHold = 0
				end, 300)
		end
		-- Put the gold into a temporary holder so we can add it up --
		JunkIt.GoldGainHold = JunkIt.GoldGainHold + _iGoldAmount
	elseif _iGoldAmount < 0 then
		-- If the gold holder is empty then we need to start a new (delayed) print gold message --
		if JunkIt.GoldLostHold == 0 then
			zo_callLater(function() 
				JunkIt.PrintGoldMessage(_Reason, false) 
				JunkIt.GoldLostHold = 0
				end, 300)
		end
		-- Put the gold into a temporary holder so we can add it up --
		JunkIt.GoldLostHold = JunkIt.GoldLostHold + _iGoldAmount
	end
end


